"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = getVariables;

var _less = require("less");

function collect(node, context) {
    var variables = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = node.rules[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var rule = _step.value;

            if (rule.isRuleset) collect(rule, context, variables);else if (rule.importedFilename) collect(rule.root, context, variables);else if (rule.variable === true) {
                var name = rule.name.substring(1);
                var value = rule.value.eval(context);

                // save under all aliases
                variables[name] = value.toCSS(context);
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    return variables;
} // Solution inspired by https://github.com/aarki/grunt-lessvars
function getVariables(content, cb) {
    var variables = (0, _less.parse)(content).then(function (root) {
        return collect(root, new _less.contexts.Eval({}, [(0, _less.transformTree)(root)]));
    });

    if (cb) {
        variables.then(function (vars) {
            return cb(null, vars);
        }).catch(function (err) {
            return cb(err);
        });
    }
    return variables;
};
